//
//  ViewController.m
//  bcpodTest
//
//  Created by shan yi on 2019/8/27.
//  Copyright © 2019 shan yi. All rights reserved.
//

#import "ViewController.h"
#import <AlibcTradeSDK/AlibcTradeSDK.h>
//#import <AlibabaAuthSDK/albbsdk.h>
#import "ALiTradeSDKShareParam.h"
#import "ALiTradeWebViewController.h"
#import "AlibcTradeConfigViewController.h"

#import <AlibabaAuthEntrance/ALBBSDK.h>
#import <AlibabaAuthEntrance/ALBBCompatibleSession.h>


@interface ViewController ()


@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self initTableView];
    [self initData];
}

- (void)initData {
    self.title = @"百川SDK使用示例";
    self.pluginTitleList = @[MODULE_ALiTRADELOGIN,MODULE_ALiTRADELOGOUT,MODULE_ALiTRADEDEMO];
    
    self.pluginClassNameList = @[MODULE_ALiTradeAPIDEMO_LOGIN,MODULE_ALiTradeAPIDEMO_LOGOUT,MODULE_ALiTradeAPIDEMO_CLASS];
    [self initTitles];
    [self initClassNames];
}

- (void)initTableView
{
    self.tableView = [[UITableView alloc] initWithFrame:self.view.bounds style:UITableViewStyleGrouped];
    self.tableView.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    self.tableView.delegate   = self;
    self.tableView.dataSource = self;
    
    [self.view addSubview:self.tableView];
}

#pragma mark - UITableViewDataSource

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.titles[section] count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    switch (section)
    {
        case 0:
            return @"功能验证入口";
        default:
            return @"";
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *mainViewController = @"MainViewController";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:mainViewController];
    if (cell == nil)
    {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:mainViewController];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    cell.textLabel.text = self.titles[indexPath.section][indexPath.row];
    cell.detailTextLabel.text = self.classNames[indexPath.section][indexPath.row];
    return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    NSString *className = self.classNames[indexPath.section][indexPath.row];
    if ([className isEqualToString:MODULE_ALiTradeAPIDEMO_CLASS]) {
        AlibcTradeConfigViewController * viewcontroller=[AlibcTradeConfigViewController new];
        viewcontroller.title=@"电商交易";
        [self.navigationController pushViewController:viewcontroller animated:YES];
        
    } else if([className isEqualToString:MODULE_ALiTradeAPIDEMO_LOGOUT]){
        
        [[ALBBSDK sharedInstance] logout];
    }
    else if([className isEqualToString:MODULE_ALiTradeAPIDEMO_LOGIN]){
        if(![[ALBBCompatibleSession sharedInstance] isLogin]) {
            [[ALBBSDK sharedInstance] setH5Only:NO];
            [[ALBBSDK sharedInstance] auth:self successCallback:^{
                NSString *tip = [NSString stringWithFormat:@"登录的用户信息:%@",[[ALBBCompatibleSession sharedInstance] getUser]];
                NSLog(@"%@", tip);
            } failureCallback:^(NSError *error) {
                NSString *tip=[NSString stringWithFormat:@"登录失败:%@",@""];
                NSLog(@"%@", tip);
            }];

        } else {
            NSString *tip = [NSString stringWithFormat:@"登录的用户信息:%@",[[ALBBCompatibleSession sharedInstance] getUser]];
            NSLog(@"%@", tip);
        }
    }else {
        UIViewController *subViewController = [[NSClassFromString(className) alloc] init];
        subViewController.title   = self.titles[indexPath.section][indexPath.row];
        [self.navigationController pushViewController:(UIViewController*)subViewController animated:NO];
    }
    
}


#pragma mark - Initialization

- (void)initTitles
{
    NSArray *pluginsTitles = self.pluginTitleList;
    self.titles = [NSArray arrayWithObjects:pluginsTitles, nil];
}

- (void)initClassNames
{
    NSArray *pluginsClassNames = self.pluginClassNameList;
    self.classNames = [NSArray arrayWithObjects:pluginsClassNames, nil];
}
@end
