//
//  ALiTradeServiceAPIViewController.m
//  NBSDK
//
//  Created by com.alibaba on 16/5/31.
//  Copyright © 2016年 com.alibaba. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ALiTradeServiceAPIViewController.h"
#import "ALiTradeTestData.h"
#import <AlibcTradeSDK/AlibcTradeSDK.h>
#import <AlibcTradeSDK/AlibcTradeService.h>
#import <AlibcTradeSDK/AlibcTradePageFactory.h>
#import "ALiTradeSDKShareParam.h"
#import "UIKit/UIKit.h"

@interface ALiTradeServiceAPIViewController()
@property (nonatomic) OneSDKItemType itemType;
@property (nonatomic, strong) ALiTradeTestData *tradeTestData;
@end


@implementation ALiTradeServiceAPIViewController
- (void)viewDidLoad {
    [super viewDidLoad];
    _tradeTestData = [[ALiTradeTestData alloc] init];
    self.itemType = OneSDKItemType_TAOBAO1;
    [self changeItemTypeAction:0];
    _onTradeSuccess=^(AlibcTradeResult *tradeProcessResult){
        if(tradeProcessResult.result ==AlibcTradeResultTypePaySuccess){
            NSString *tip=[NSString stringWithFormat:@"交易成功:成功的订单%@\n，失败的订单%@\n",[tradeProcessResult payResult].paySuccessOrders,[tradeProcessResult payResult].payFailedOrders];
            NSLog(@"%@",tip);
        }else if(tradeProcessResult.result==AlibcTradeResultTypeAddCard){
        }
    };
    _onTradeFailure=^(NSError *error){
//        退出交易流程
        if (error.code==AlibcErrorCancelled) {
            return ;
        }
        NSDictionary *infor=[error userInfo];
        NSArray*  orderid=[infor objectForKey:@"orderIdList"];
        NSString *tip=[NSString stringWithFormat:@"交易失败:\n订单号\n%@",orderid];
        NSLog(@"%@",tip);
    };    
}

#pragma mark - Initialization
- (IBAction)TextField_DidEndOnExit:(id)sender {
    // 隐藏键盘.
    [sender resignFirstResponder];
}

- (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString
{
    if (jsonString == nil) {
        return nil;
    }
    
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers
                                                          error:&err];
    if(err)
    {
        NSLog(@"json解析失败：%@",err);
        return nil;
    }
    return dic;
}

-(AlibcTradeTaokeParams*)taokeParam{
    if ([ALiTradeSDKShareParam sharedInstance].isUseTaokeParam) {
        AlibcTradeTaokeParams *taoke = [[AlibcTradeTaokeParams alloc] init];
        taoke.pid =[[ALiTradeSDKShareParam sharedInstance].taoKeParams objectForKey:@"pid"];
        taoke.subPid = [[ALiTradeSDKShareParam sharedInstance].taoKeParams objectForKey:@"subPid"];
        taoke.unionId = [[ALiTradeSDKShareParam sharedInstance].taoKeParams objectForKey:@"unionId"];
        
        taoke.adzoneId = [[ALiTradeSDKShareParam sharedInstance].taoKeParams objectForKey:@"adzoneId"];
        id extParams =  [[ALiTradeSDKShareParam sharedInstance].taoKeParams objectForKey:@"extParams"];
        if([extParams isKindOfClass:[NSDictionary class]]){
            taoke.extParams = extParams;
        }else {
            // 解析字符串
            taoke.extParams = [self dictionaryWithJsonString:extParams];
        }
        return taoke;
    } else {
        return nil;
    }
    
}
-(NSDictionary *)customParam{
    NSDictionary *customParam=[NSDictionary dictionaryWithDictionary:[ALiTradeSDKShareParam sharedInstance].customParams];
    return customParam; 
    
}
- (AlibcOpenType)openType{
    
    AlibcOpenType openType=AlibcOpenTypeAuto;
    switch ([ALiTradeSDKShareParam sharedInstance].openType) {
        case 0:
            openType=AlibcOpenTypeAuto;
            break;
        case 1:
            openType=AlibcOpenTypeNative;
            break;
        default:
            break;
    }
    return openType;
}
-(AlibcNativeFailMode )NativeFailMode{
    AlibcNativeFailMode openType=AlibcNativeFailModeJumpH5;
    switch ([ALiTradeSDKShareParam sharedInstance].NativeFailMode) {
        case 0:
            openType=AlibcNativeFailModeJumpH5;
            break;
        case 1:
            openType=AlibcNativeFailModeJumpDownloadPage;
            break;
        case 2:
            openType=AlibcNativeFailModeNone;
            break;
        default:
            break;
    }
    return openType;
    
}
-(NSString*)schemeType{
  NSString*  linkKey=@"tmall";
    switch ([ALiTradeSDKShareParam sharedInstance].linkKey) {
        case 0:
            linkKey=@"taobao";
            break;
        case 1:
            linkKey=@"tmall";
            break;
        default:
            break;
    }
    return linkKey;
//    return nil;

}

// 打开URL（包括H5、唤起手淘等）
- (IBAction)openUrl:(id)sender {
    [self openPageByNewWay:_pageUrl.text];
}

- (IBAction)openItemDetail:(id)sender {
    id<AlibcTradePage> page = [AlibcTradePageFactory itemDetailPage:_itemID.text];
    [self OpenPageByNewWay:page BizCode:@"detail"];
    
}

- (IBAction)openShop:(id)sender {
    id<AlibcTradePage> page= [AlibcTradePageFactory shopPage:_shopID.text];
    [self OpenPageByNewWay:page BizCode:@"shop"];
}

- (IBAction)openCart:(id)sender {
    id<AlibcTradePage> page = [AlibcTradePageFactory myCartsPage];
    [self OpenPageByNewWay:page BizCode:@"cart"];

}

- (void)openPageByNewWay:(NSString *)url {
    AlibcTradeShowParams* showParam = [[AlibcTradeShowParams alloc] init];
    showParam.openType = [self openType];
    showParam.isNeedCustomNativeFailMode = [ALiTradeSDKShareParam sharedInstance].isNeedCustomFailMode;
    //    showParam.backUrl=@"tbopen23082328:https://h5.m.taobao.com";
    BOOL isNeedPush=[ALiTradeSDKShareParam sharedInstance].isNeedPush;
    showParam.isNeedPush=isNeedPush;
    showParam.nativeFailMode=[self NativeFailMode];
    showParam.linkKey=[self schemeType];
    showParam.degradeUrl = [ALiTradeSDKShareParam sharedInstance].degardeUrl;
    
    BOOL isBindWebview=[ALiTradeSDKShareParam sharedInstance].isBindWebview;
    if(isBindWebview){
        ALiTradeWebViewController* view = [[ALiTradeWebViewController alloc] init];
        NSInteger res  =  [[AlibcTradeSDK sharedInstance].tradeService openByUrl:url identity:@"trade" webView:view.webView parentController:view showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
        if (res == 1) {
            [self.navigationController pushViewController:view animated:YES];
        }
        
    }else {
        if(isNeedPush){
            NSInteger res  =  [[AlibcTradeSDK sharedInstance].tradeService openByUrl:url identity:@"trade" webView:nil parentController:self.navigationController showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
            
            if (res == 1) {
                
            }
        }else {
              [[AlibcTradeSDK sharedInstance].tradeService openByUrl:url identity:@"trade" webView:nil parentController:self showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
        }
    }
}


- (void)OpenPageByNewWay:(id<AlibcTradePage>)page BizCode:(NSString *)bizCode{
    AlibcTradeShowParams* showParam = [[AlibcTradeShowParams alloc] init];
    showParam.openType = [self openType];
    //    showParam.backUrl=@"tbopen23082328:https://h5.m.taobao.com";
    BOOL isNeedPush=[ALiTradeSDKShareParam sharedInstance].isNeedPush;
    BOOL isBindWebview=[ALiTradeSDKShareParam sharedInstance].isBindWebview;
    showParam.isNeedPush=isNeedPush;
    showParam.nativeFailMode=[self NativeFailMode];
    showParam.isNeedCustomNativeFailMode = [ALiTradeSDKShareParam sharedInstance].isNeedCustomFailMode;
    showParam.linkKey=[self schemeType];
    showParam.degradeUrl = [ALiTradeSDKShareParam sharedInstance].degardeUrl;
    if (isBindWebview) {
        ALiTradeWebViewController* view = [[ALiTradeWebViewController alloc] init];
        NSInteger res  =  [[AlibcTradeSDK sharedInstance].tradeService openByBizCode:bizCode page:page webView:view.webView parentController:view showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
        if (res == 1) {
            [self.navigationController pushViewController:view animated:YES];
        }
    } else {
        if (isNeedPush) {
             [[AlibcTradeSDK sharedInstance].tradeService openByBizCode:bizCode page:page webView:nil parentController:self.navigationController showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
           
        } else {
             [[AlibcTradeSDK sharedInstance].tradeService openByBizCode:bizCode page:page webView:nil parentController:self showParams:showParam taoKeParams:[self taokeParam] trackParam:[self customParam] tradeProcessSuccessCallback:self.onTradeSuccess tradeProcessFailedCallback:self.onTradeFailure];
            
        }
        
    }
}

- (IBAction)isUserRealItemID:(UISwitch *)sender {
    [self changeItemTypeAction:_itemTypeSeg];
}


- (void)changeItemTypeAction:(UISegmentedControl *)sender {
    
    self.itemType = sender.selectedSegmentIndex;
    ALiTradeTestData *data = [[ALiTradeTestData alloc]init];
        switch (self.itemType) {
            case OneSDKItemType_TAOBAO1:
            {
                data.pageUrl =RELEASEURL_TB1;
                data.taokePageUrl=RELEASETAOKEURL_TB1;
                data.realItemId = RELEASEREALITEMID_TB1;
                data.shopId=RELEASESHOPID_TB1;
                data.itemType = RELEASEITEMTYPE_TB1;
                data.openItemId1 = RELEASEITEMID_TB1;
                data.skuId1 = RELEASESKUID_TB1;
                data.openItemId2 = RELEASEITEMID_TB2;
                data.skuId2 = RELEASESKUID_TB2;
                data.promotiontype = @"shop";
                data.promotionparam = RELEASESELLNICK;
                break;
            }
            case OneSDKItemType_TAOBAO2:
            {
                data.pageUrl =RELEASEURL_TB2;
                data.taokePageUrl=RELEASETAOKEURL_TB2;
                data.realItemId = RELEASEREALITEMID_TB2;
                data.shopId=RELEASESHOPID_TB2;
                data.itemType = RELEASEITEMTYPE_TB2;
                data.openItemId1 = RELEASEITEMID_TB2;
                data.skuId1 = RELEASESKUID_TB2;
                data.openItemId2 = RELEASEITEMID_TB1;
                data.skuId2 = RELEASESKUID_TB1;
                data.promotiontype = @"shop";
                data.promotionparam = RELEASESELLNICK;
                
                break;
            }
            case OneSDKItemType_TMALL1:
            {
                data.pageUrl =RELEASEURL_TM1;
                
                data.taokePageUrl=RELEASETAOKEURL_TM1;
                
                data.realItemId = RELEASEREALITEMID_TM1;
                data.shopId=RELEASESHOPID_TM1;
                
                data.itemType = RELEASEITEMTYPE_TM1;
                data.openItemId1 = RELEASEITEMID_TM1;
                
                data.skuId1 = RELEASESKUID_TM1;
                data.openItemId2 = RELEASEITEMID_TM2;
                data.skuId2 = RELEASESKUID_TM2;
                data.promotiontype = @"auction";
                data.promotionparam = RELEASEITID;
                break;
            }
            case OneSDKItemType_TMALL2:
            {
                data.pageUrl =RELEASEURL_TM2;
                data.taokePageUrl=RELEASETAOKEURL_TM2;
                data.realItemId = RELEASEREALITEMID_TM2;
                data.shopId=RELEASESHOPID_TM2;
                data.itemType = RELEASEITEMTYPE_TM2;
                data.openItemId1 = RELEASEITEMID_TM2;
                data.skuId1 = RELEASESKUID_TM2;
                data.openItemId2 = RELEASEITEMID_TM1;
                data.skuId2 = RELEASESKUID_TM1;
                data.promotiontype = @"auction";
                data.promotionparam = RELEASEITID;
                break;
            }
            default:
                break;
        }
        data.taoKePid = RELEASETAOKEPID;
        data.taoKeUnionId = RELEASETAOKEUNIONID;
        if (data.taoKePid!=nil) {
            [ALiTradeSDKShareParam sharedInstance].taoKeParams[@"pid"] = data.taoKePid;
        }
        if (data.taoKeUnionId!=nil) {
            [ALiTradeSDKShareParam sharedInstance].taoKeParams[@"unionId"] = data.taoKeUnionId;
        }
        data.eticketorderid = RELEASEORDERID;
    
    if ([_isUserRealid isOn]) {
        _itemID.text=data.realItemId;
        _MiniItemID.text=data.realItemId;
        _add2CartItemID.text=data.realItemId;
        _pageUrl.text=data.pageUrl;
        _requestUrl.text=data.pageUrl;
    } else {
        _itemID.text=data.openItemId1;
        _MiniItemID.text=data.openItemId1;
        _add2CartItemID.text=data.openItemId1;
        _pageUrl.text=data.taokePageUrl;
        _requestUrl.text=data.pageUrl;
        
    }
    _shopID.text=data.shopId;
    _myOrderStatus.text=[NSString stringWithFormat:@"%li",(long)sender.selectedSegmentIndex];
    _tradeTestData = data;

}


@end
