//
//  AlibcTradeConfigViewController.m
//  NBdemo
//  Created by com.alibaba on 15/11/3.
//  Copyright © 2019 com.alibaba. All rights reserved.
//

#import "AlibcTradeConfigViewController.h"
#import "AlibcTradeShowParamsConfigViewController.h"
#import "AlibcTradeTaokeParamsConfigViewController.h"
#import "ALiTradeSDKShareParam.h"
#import <AlibcTradeSDK/AlibcTradeSDK.h>

@interface AlibcTradeConfigViewController ()

@property(nonatomic,assign)BOOL isFirst;

@end

@implementation AlibcTradeConfigViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.isFirst = YES;
    // Do any additional setup after loading the view from its nib.
    [[AlibcTradeSDK sharedInstance] setIsSyncForTaoke:[_isSyncForTaoke isOn]];
    [[AlibcTradeSDK sharedInstance] setShouldUseAlizfNative:[_isUseNativeAlipay isOn]];
    [ALiTradeSDKShareParam sharedInstance].isUseTaokeParam=[_isUseTaokeParam isOn];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}

- (IBAction)isSyncTaokeTrace:(id)sender {
    BOOL isSync=[sender isOn];
    [[AlibcTradeSDK sharedInstance] setIsSyncForTaoke:isSync];
}

- (IBAction)isNeedNativeAliPay:(id)sender {
     [[AlibcTradeSDK sharedInstance] setShouldUseAlizfNative:[sender isOn]];
}

- (IBAction)isNeedTaokeParams:(id)sender {
    [ALiTradeSDKShareParam sharedInstance].isUseTaokeParam=[sender isOn];
}

- (IBAction)openShowParamsEdit:(id)sender {
    AlibcTradeShowParamsConfigViewController *vc = [[AlibcTradeShowParamsConfigViewController alloc]init];
    [self.navigationController pushViewController:vc animated:YES];
}

- (IBAction)openTaokeParams:(id)sender {
    AlibcTradeTaokeParamsConfigViewController *vc = [[AlibcTradeTaokeParamsConfigViewController alloc]init];
    [self.navigationController pushViewController:vc animated:YES];
}

- (IBAction)openTrackParams:(id)sender {
    [ALiTradeSDKShareParam sharedInstance].externParams=[ALiTradeSDKShareParam sharedInstance].customParams;
    UIStoryboard *storyboard = [UIStoryboard storyboardWithName:@"ALiTradeParamConfigViewController" bundle:nil];
    UIViewController * viewcontroller=[storyboard instantiateViewControllerWithIdentifier:@"ALiTradeParamConfigViewController"];
    viewcontroller.title=@"业务参数编辑";
    [self.navigationController pushViewController:viewcontroller animated:YES];
}
- (IBAction)openTradePageTest:(id)sender {
    UIStoryboard *storyboard = [UIStoryboard storyboardWithName:@"ALiTradeServiceAPIViewController" bundle:nil];
    UIViewController * viewcontroller=[storyboard instantiateViewControllerWithIdentifier:@"ALiTradeServiceAPIViewController"];
    viewcontroller.title=@"电商接口";
    [self.navigationController pushViewController:viewcontroller animated:YES];
}

@end
